#include "window.h"

#include <stdlib.h>

#include "gl.h"

void tick();
struct window *tick_window;

struct window *sw_window_create(struct vec2i size, char *title) {
	struct window *win;

	win = malloc(sizeof(struct window));
	win->size = size;

	glfwInit();
	glfwDefaultWindowHints();

	win->_window = glfwCreateWindow(size.x, size.y, title, 0, 0);
	glfwShowWindow(win->_window);
	glfwMakeContextCurrent(win->_window);
	glewInit();
	glfwSwapInterval(1);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);

	glClearColor(0.1f, 0.2f, 0.3f, 1.f);
	return win;
}

void sw_window_run(struct window *window) {
	tick_window = window;
#ifdef __EMSCRIPTEN__
	emscripten_set_main_loop(tick, 60, 1);
#else
	while (!glfwWindowShouldClose(window->_window)) {
		tick();
	}
#endif
}

/* private functions */

void tick() {
	glClear(GL_COLOR_BUFFER_BIT);
	glfwSwapBuffers(tick_window->_window);
	glfwPollEvents();
}
